freeslot("SKINCOLOR_CFIGHTER", "S_PLAY_CFSWITCH", "sfx_clswtc", "sfx_cldone", "SPR_CLSW")
sfxinfo[sfx_clswtc].caption = "Switching..."
sfxinfo[sfx_cldone].caption = "Switch complete"


skincolors[SKINCOLOR_CFIGHTER] = {
	name = "Clone Fighter",
	ramp = {0,0,1,3,5,7,9,11,13,15,17,19,22,25,28,31},
	invcolor = SKINCOLOR_CRIMSON,
	invshade = 3, 
	chatcolor = V_GRAYMAP,
	accessible = true
}

states[S_PLAY_CFSWITCH] = {
        sprite = SPR_CLSW,
        frame = FF_ANIMATE,
        tics = -1,
        nextstate = S_PLAY_JUMP
}

local primaryRamp = {0,0,1,3,5,7,9,11,13,15,17,19,22,25,28,31}
local secondaryRamp = {0,2,4,6,8,10,12,14,16,18,20,22,24,26,29,31}

addHook("ThinkFrame", function()
	if leveltime % 2 == 1 then
		skincolors[SKINCOLOR_CFIGHTER].ramp = secondaryRamp
	else
		skincolors[SKINCOLOR_CFIGHTER].ramp = primaryRamp
	end
end)

-- I/O stuff begins here - Thanks to Sz_ for the reusable script
--script was written by LJ & gained permission to post it

local function writeCvar(file, cvarname)
	local cvar = CV_FindVar(cvarname)
	file:write(cvar.string, "\n")
end

local function readCvar(file, cvarname)
	local value = file:read("*l")
	COM_BufInsertText(consoleplayer, cvarname .. ' "' .. value .. '"')
end

local function saveConfig(configname)
	-- Open the file ("w" means we will write data to it)
	local file = io.openlocal(configname, "w")

	if file then
		writeCvar(file, "clone_switchnext")
		writeCvar(file, "clone_switchprev")

		file:close() -- We're done, close the file now
	else
		print(configname.." not found.")
	end
end

local function loadConfig(configname)
	-- Open the file ("r" means we will read data from it)
	local file = io.openlocal(configname, "r")

	if file then
		readCvar(file, "clone_switchnext")
		readCvar(file, "clone_switchprev")

		file:close() -- We're done, close the file now
	else
		print(configname.." not found.")
	end
end

local buttonValues = {
	WeaponNext = 1,
	WeaponPrev = 2,
	FireNormal = 3,
	TossFlag = 4,
	Custom1 = 5,
	Custom2 = 6,
	Custom3 = 7
}
local cv_clswitchn = CV_RegisterVar({"clone_switchnext", "WeaponNext", 0, buttonValues})
local cv_clswitchp = CV_RegisterVar({"clone_switchprev", "WeaponPrev", 0, buttonValues})


loadConfig("client/Clone Fighter/cfButtons.dat")
print("Loaded Clone Fighter's button configuration.")

addHook("GameQuit", function()
	saveConfig("client/Clone Fighter/cfButtons.dat")
end)